<?php

namespace Ulmus\Annotation\Property;

class Relation implements \Ulmus\Annotation\Annotation {

    public string $type;

    public /*stringable*/ $key;

    public /*stringable*/ $foreignKey;

    public array $foreignKeys;

    public string $bridge;

    public /*stringable*/ $bridgeKey;

    public /*stringable*/ $bridgeForeignKey;
    
    public string $entity;
    
    public string $function = "loadAll";

    public function __construct(string $type = null)
    {
        if ( $type !== null ) {
            $this->type = $type;
        }
    }
    
    public function entity() {
        try {
            $e = $this->entity;        
        } catch (\Throwable $ex) {
            throw new \Exception("Your @Relation annotation seems to be missing an `entity` entry.");
        }
        
        return new $e();
    }
    
    public function bridge() {
        $e = $this->bridge;
        
        return new $e();
    }
}
