<?php

namespace Ulmus\Annotation\Property;

use Ulmus\Query;

class Where implements \Ulmus\Annotation\Annotation {

    public string $field;
    
    public $value;
    
    public string $operator;
    
    public string $condition;
    
    public function __construct(? string $field = null, $value = null, ? string $operator = null, ? string $condition = null)
    {
        if ( $field !== null ) {
            $this->field = $field;
        }
        
        if ( $value !== null ) {
            $this->value = $value;
        }
        
        $this->operator = $operator !== null ? $operator : Query\Where::OPERATOR_EQUAL; 
        $this->condition = $condition !== null ? $condition : Query\Where::CONDITION_AND; 
    }
}
